---
title: MediaStreamTrack
slug: Web/API/MediaStreamTrack
tags:
  - API
  - Audio
  - Interface
  - Media
  - Media Capture and Streams API
  - Media Streams API
  - MediaStreamTrack
  - Reference
  - Video
  - WebRTC
---
<div>{{APIRef("Media Capture and Streams")}}</div>

<p><span class="seoSummary">The <strong><code>MediaStreamTrack</code></strong> interface represents a single media track within a stream; typically, these are audio or video tracks, but other track types may exist as well.</span></p>

<h2 id="Properties">Properties</h2>

<p>In addition to the properties listed below, <code>MediaStreamTrack</code> has constrainable properties which can be set using {{domxref("MediaStreamTrack.applyConstraints", "applyConstraints()")}} and accessed using {{domxref("MediaStreamTrack.getConstraints", "getConstraints()")}} and {{domxref("MediaStreamTrack.getSettings", "getSettings()")}}. See <a href="/en-US/docs/Web/API/Media_Streams_API/Constraints">Capabilities, constraints, and settings</a> to learn how to correctly work with constrainable properties. Not doing so correctly will result in your code being unreliable.</p>

<dl>
 <dt>{{domxref("MediaStreamTrack.contentHint")}}</dt>
 <dd>A string that may be used by the web application to provide a hint as to what type of content the track contains to guide how it should be treated by API consumers.</dd>
 <dt>{{domxref("MediaStreamTrack.enabled")}}</dt>
 <dd>A Boolean whose value of <code>true</code> if the track is enabled, that is allowed to render the media source stream; or <code>false</code> if it is disabled, that is not rendering the media source stream but silence and blackness. If the track has been disconnected, this value can be changed but has no more effect.
 <div class="note"><strong>Note:</strong> You can implement standard "mute" functionality by setting <code>enabled</code> to <code>false</code>. The <code>muted</code> property refers to a condition in which there's no media because of a technical issue.</div>
 </dd>
 <dt>{{domxref("MediaStreamTrack.id")}} {{readonlyInline}}</dt>
 <dd>Returns a {{domxref("DOMString")}} containing a unique identifier (GUID) for the track; it is generated by the browser.</dd>
 <dt>{{domxref("MediaStreamTrack.isolated")}} {{readonlyInline}}</dt>
 <dd>Returns a Boolean value which is <code>true</code> if the track is <strong>isolated</strong>; that is, the track cannot be accessed by the document that owns the <code>MediaStreamTrack</code>. This happens when the {{domxref("MediaStreamTrack.peerIdentity", "peerIdentity")}} property is set, or if the track comes from a cross-origin source.</dd>
 <dt>{{domxref("MediaStreamTrack.kind")}} {{readonlyInline}}</dt>
 <dd>Returns a {{domxref("DOMString")}} set to <code>"audio"</code> if the track is an audio track and to <code>"video"</code>, if it is a video track. It doesn't change if the track is deassociated from its source.</dd>
 <dt>{{domxref("MediaStreamTrack.label")}} {{readonlyInline}}</dt>
 <dd>Returns a {{domxref("DOMString")}} containing a user agent-assigned label that identifies the track source, as in <code>"internal microphone"</code>. The string may be left empty and is empty as long as no source has been connected. When the track is deassociated from its source, the label is not changed.</dd>
 <dt>{{domxref("MediaStreamTrack.muted")}} {{readonlyInline}}</dt>
 <dd>Returns a Boolean value indicating whether the track is unable to provide media data due to a technical issue.
 <div class="note"><strong>Note:</strong> You can implement standard "mute" functionality by setting <code>enabled</code> to <code>false</code>, and unmute the media by setting it back to <code>true</code> again.</div>
 </dd>
 <dt>{{domxref("MediaStreamTrack.readonly")}} {{readonlyInline}}</dt>
 <dd>Returns a Boolean value with a value of <code>true</code> if the track is readonly (such a video file source or a camera that settings can't be modified), <code>false</code> otherwise.</dd>
 <dt>{{domxref("MediaStreamTrack.readyState")}} {{readonlyInline}}</dt>
 <dd>Returns an enumerated value giving the status of the track. This will be one of the following values:
 <ul>
  <li><code>"live"</code> which indicates that an input is connected and does its best-effort in providing real-time data. In that case, the output of data can be switched on or off using the {{domxref("MediaStreamTrack.enabled", "enabled")}} attribute.</li>
  <li><code>"ended"</code> which indicates that the input is not giving any more data and will never provide new data.</li>
 </ul>
 </dd>
 <dt>{{domxref("MediaStreamTrack.remote")}} {{readonlyInline}} {{deprecated_inline}}</dt>
 <dd>Returns a Boolean with a value of <code>true</code> if the track is sourced by a {{domxref("RTCPeerConnection")}}, <code>false</code> otherwise.</dd>
</dl>

<h2 id="Methods">Methods</h2>

<dl>
 <dt>{{domxref("MediaStreamTrack.applyConstraints()")}}</dt>
 <dd>Lets the application specify the ideal and/or ranges of acceptable values for any number of the available constrainable properties of the <code>MediaStreamTrack</code>.</dd>
 <dt>{{domxref("MediaStreamTrack.clone()")}}</dt>
 <dd>Returns a duplicate of the <code>MediaStreamTrack</code>.</dd>
 <dt>{{domxref("MediaStreamTrack.getCapabilities()")}}</dt>
 <dd>Returns the a list of constrainable properties available for the <code>MediaStreamTrack</code>.</dd>
 <dt>{{domxref("MediaStreamTrack.getConstraints()")}}</dt>
 <dd>Returns a {{domxref('MediaTrackConstraints')}} object containing the currently set constraints for the track; the returned value matches the constraints last set using {{domxref("MediaStreamTrack.applyConstraints", "applyConstraints()")}}.</dd>
 <dt>{{domxref("MediaStreamTrack.getSettings()")}}</dt>
 <dd>Returns a {{domxref("MediaTrackSettings")}} object containing the current values of each of the <code>MediaStreamTrack</code>'s constrainable properties.</dd>
 <dt>{{domxref("MediaStreamTrack.stop()")}}</dt>
 <dd>Stops playing the source associated to the track, both the source and the track are deassociated. The track state is set to <code>ended</code>.</dd>
</dl>

<h2 id="Events">Events</h2>

<p>Listen to these events using {{domxref("EventTarget.addEventListener", "addEventListener()")}} or by assigning an event listener to the <code>on<em>eventname</em></code> property of this interface:</p>

<dl>
 <dt>{{domxref("MediaStreamTrack/ended_event", "ended")}}</dt>
 <dd>Sent when playback of the track ends (when the value {{domxref("MediaStreamTrack.readyState", "readyState")}} changes to <code>ended</code>).<br>
 Also available using the {{domxref("MediaStreamTrack/onended", "onended")}} event handler property.</dd>
 <dt>{{domxref("MediaStreamTrack/mute_event", "mute")}}</dt>
 <dd>Sent to the <code>MediaStreamTrack</code> when the value of the {{domxref("MediaStreamTrack.muted", "muted")}} property is changed to <code>true</code>, indicating that the track is unable to provide data temporarily (such as when the network is experiencing a service malfunction).<br>
 Also available using the {{domxref("MediaStreamTrack/onmute", "onmute")}} event handler property.</dd>
 <dt>{{domxref("MediaStreamTrack/isolationchange_event", "isolationchange")}}</dt>
 <dd>Sent whenever the value of the {{domxref("MediaStreamTrack.isolated", "isolated")}} property changes due to the document gaining or losing permission to access the track.<br>
 Also available through the {{domxref("MediaStreamTrack/onisolationchange", "onisolationchange")}} event handler property.</dd>
 <dt>{{domxref("MediaStreamTrack/overconstrained_event", "overconstrained")}} {{deprecated_inline}}</dt>
 <dd>Sent when the constraints specified for the track cause the track to be incompatible and therefore to not be used.<br>
 Also available through the {{domxref("MediaStreamTrack/onoverconstrained", "onoverconstrained")}} event handler property.</dd>
 <dt>{{domxref("MediaStreamTrack/unmute_event", "unmute")}}</dt>
 <dd>Sent to the track when data becomes available again, ending the <code>muted</code> state.<br>
 Also available through the {{domxref("MediaStreamTrack/onunmute", "onunmute")}} event handler property.</dd>
</dl>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName("WebRTC Identity", "#isolated-track", "Isolated tracks")}}</td>
   <td>{{Spec2("WebRTC Identity")}}</td>
   <td>Additional properties for isolated track support</td>
  </tr>
  <tr>
   <td>{{SpecName('Media Capture', '#mediastreamtrack', 'MediaStreamTrack')}}</td>
   <td>{{Spec2('Media Capture')}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.MediaStreamTrack")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/Media_Streams_API">Media Capture and Streams API</a></li>
 <li>{{domxref("MediaStream")}}</li>
</ul>
